import requests
from requests.auth import HTTPProxyAuth

def test(proxy):

    # print(f'http://{proxy.usr}:{proxy.pwd}@{proxy.url}:{proxy.port}')

    s = requests.Session()
    url = "http://example.com"
    proxies = {
            'http': f'http://{proxy.url}:{proxy.port}',
            'https': f'http://{proxy.url}:{proxy.port}'
    }
    auth = HTTPProxyAuth(proxy.usr, proxy.pwd)

    s.proxies = proxies
    s.auth = auth

    try:
        r = s.get(url)

        if r.status_code == 200:
            proxy.isworking = True
        else:
            print(r.text)
            proxy.isworking = False

        print(f"{r.status_code} -> {proxy.isworking}")

    except Exception as e:
        print(f"Connection error! (Check proxy)\n\n{e}")
        proxy.isworking = False


class Proxy:

    def __init__(self):

        self.name = None
        self.url = None
        self.port = None
        self.usr = None
        self.pwd = None
        self.isworking = None
